#!/usr/bin/perl

require 'utils.pl';

$printCap = "printcap"; # default: "/etc/printcap"
$lpc = "lpc";

# Primero nos aseguramos que el demonio de impresion vive.
open(LPD, "ps ax |") || die "No encuentro `ps'\n"; 
@tmp = grep(/lpd/, <LPD>);

if ($#tmp < 0) {
   printer_out(0);  # No tiene caso seguir
   exit 0;
 }

# OK, sabemos que si hay un demonio corriendo, entonces
# busquemos las impresoras:
close(LPD);

open(PRINTERS,$printCap);
@printers = grep(!/^#|^[ \t\n]+:|^[ \t\n]*$/, <PRINTERS>);
close(PRINTERS);

# Ya sabemos cuantas hay configuradas y como se llaman.
# Ahora saquemos el status de cada una de ellas.
$queuing = $printing = $entries = $i = 0;
$count = @printers;

while(@printers) {
  # en el arreglo estan como "NOMBRE:/", entonces nos 
  # quedamos con solo el nombre asi:
  $name = shift @printers;
  $name =~ s/(.*):.*/$1/;

  # Ahora checamos su estatus:
  open(STATUS, $lpc . " status " . $name . " |") || die "No jala lpc!\n";
  read_status(grep(!/^[a-zA-Z0-9]+:/, <STATUS>));
  close(STATUS);
  printer_out(1,$name,$i);
  $i++;
}

sub read_status {
  while(@_) {
    $line = shift @_;
    chop($line);
    @tmp = split(' ',$line);
    $queuing = $tmp[2] if $tmp[0] eq "queuing";
    $printing = $tmp[2] if $tmp[0] eq "printing";
    $entries = $tmp[0] if $tmp[1] eq "entries";
  }
}

sub printer_out {
  $sep = ":";
  $ind = $_[2];
  chop($name = $_[1]);

  if($_[0] == 0) { # No hay demonio de impresion
     exit(1);
   }
  # si hay demonio de impresion
  $out[$ind] = join($sep, $name, $queuing, $printing, $entries);
}

## Ahora, abrimos un socket al servidor del monitoAd y
## transmitimos los datos.  PROTOCOLO B:
$socket = IO::Socket::INET->new(PeerAddr => $servername,
				PeerPort => $serverport,
				Proto    => "tcp",
				Type     => $SOCK_STREAM)
  or die "No me puedo conectar a $servername:$serverport : $!\n";

## Enviando "hello"  al servidor:
$id = sys_id('printer');
print $socket "$id\n";

## LEER LA RESPUESTA:
chop( $answer = <$socket> );
## IF "error"  THEN "die"
unless ( $answer eq "olleh" ) {
  die "Algo no le gust al servidor: $answer\n"
}

# enviamos la informacin de impresoras por el socket:
$i = 0;
while ($i < $count) {
  print "Enviando: $out[$i]\n";
  print $socket "$out[$i]\n";
  $i++;
}

## FIN DE LA TRANSMISION:
print $socket ".\n";

## Esperar "bye" y terminar
chop( $answer = <$socket> );
## IF "error"  THEN "die"
unless ( $answer eq "bye" ) {
  die "Algo no le gust al servidor: $answer\n"
}

