#!/usr/bin/perl

require 'utils.pl';

open (PS, 'ps -eo user,tty,state --sort user |');

$total    = 0;
$running  = 0;
$sleeping = 0;
$zombie   = 0;
$pr_system   = 0;
$pr_user     = 0;
$pr_daemon   = 0;

while($line = <PS>) {
  chop $line;
  ($user, $tty, $state) = split(' ', $line);
  
  if ($state eq "R") {
    $running++;
  } elsif ($state eq "S" || $state eq "D" || $state eq "T") {
    $sleeping++;
  } else { ## "Z"ombies
    $zombie++;
  }
  
  ## Separando por usuario: Los del sistema y los otros.
  if ($user eq "root" || $user eq "nobody" || $user eq "xfs" 
      || $user eq "bin" || $user eq "daemon") {
    $pr_system++;
  } else { $pr_user++; }

  ## Cuantos son demonios
  if ($tty eq "?") {
    $pr_daemon++;
  }

  ## Total
  $total++;

}

close (PS);

sub format_output {
  $sep = ":";
  $out = join($sep, $total, $pr_daemon, $pr_system, $pr_user, $running, $sleeping, $zombie);
}

## Ahora, abrimos un socket al servidor del Sismo y
## transmitimos los datos.
$socket = IO::Socket::INET->new(PeerAddr => $servername,
				PeerPort => $serverport,
				Proto    => "tcp",
				Type     => $SOCK_STREAM)
  or die "No me puedo conectar a $servername:$serverport : $!\n";

## Enviando "hello"  al servidor:
$id = sys_id('process');
print $socket "$id\n";

## Leyendo la respuesta:
chop( $answer = <$socket> );
## IF "error"  THEN "die"
unless ( $answer eq "olleh" ) {
  die "Algo no le gust al servidor: $answer\n"
}

# Todo va bien, as que formateamos la salida:
format_output;

# y la enviamos por el socket:
print $socket "$out\n";

## fin de la transmision:
print $socket ".\n";

## Esperar "bye" y terminar
chop( $answer = <$socket> );
## IF "error"  THEN "die"
unless ( $answer eq "bye" ) {
  die "Algo no le gust al servidor: $answer\n"
}
