#!/usr/bin/perl

require 'utils.pl';

open (DF, 'df |');

$count = 0;
$first = 1;

while($line = <DF>) {
  if ($first  == 1) { # ignore the first one
    $first = 0;
  } else {
    chop $line;
    ($fs, $bs, $use, $avail, $useper, $mountp) = split(' ',$line);
    if ($fs ne "procfs") {
      # ignoramos el sistema de archivos procfs, 
      # porque es un sistema virtual y siempre est al 100% de uso.
      # Guardamos esta informacion
      $filesystems[$count] = $fs;
      $blocks[$count] = $bs;
      $used[$count] = $use;
      $available[$count] = $avail;
      $percents[$count] = $useper;
      $points[$count] = $mountp;
      $count++;
    }
  }
}

close(DF);

sub format_output {
  $sep = ":";
  $i = 0;
 
  while ($i < $count) {
    $out[$i] = join($sep, $filesystems[$i], $blocks[$i], $used[$i], $available[$i], $percents[$i], $points[$i]);
    $i++;
  }
}

## Ahora, abrimos un socket al servidor del Sismo y
## transmitimos los datos.
$socket = IO::Socket::INET->new(PeerAddr => $servername,
				PeerPort => $serverport,
				Proto    => "tcp",
				Type     => $SOCK_STREAM)
  or die "No me puedo conectar a $servername:$serverport : $!\n";

## Enviando "hello"  al servidor:
$id = sys_id('fs');
print $socket "$id\n";

## Leyendo la respuesta:
chop( $answer = <$socket> );
## IF "error"  THEN "die"
unless ( $answer eq "olleh" ) {
  die "Algo no le gust al servidor: $answer\n"
}

# Todo va bien, as que formateamos la salida:
format_output;

# y la enviamos por el socket:
$i = 0;
while ($i < $count) {
  print $socket "$out[$i]\n";
  $i++;
}

## fin de la transmision:
print $socket ".\n";

## Esperar "bye" y terminar
chop( $answer = <$socket> );
## IF "error"  THEN "die"
unless ( $answer eq "bye" ) {
  die "Algo no le gust al servidor: $answer\n"
}
