;; Karla Ramrez Pulido

;; Definicin de tablas para el SisMo

(define odbc-version 2.5)
(require-library "schemeql.ss" "schemeql")

(load-relative "private.ss")

(define dbase (connect-to-database dbms login passwd))

;; Este es para crear la base de datos por primera vez:
(create-database "sismo")


;; Si quieres editar las tablas por alguna razn y
;; volver a cargar este archivo.  Descomenta los siguientes
;; renglones:

;; (use-database "sismo")
;; (drop-table "hosts")
;; (drop-table "admins")
;; (drop-table "admin_host")
;; (drop-table "kid")
;; (drop-table "fs")
;; (drop-table "memory")
;; (drop-table "network")
;; (drop-table "nfs")
;; (drop-table "printer")
;; (drop-table "process")
;; (drop-table "processor")
;; (drop-table "users")

(create-table hosts
	      ((hostid     smallint unsigned not-null auto-increment)
	       (ip         (char 15) not-null)
	       (hostname   (varchar 128) not-null)
	       (primary-key hostid)))

(create-table admins
	      ((adminid    smallint unsigned not-null auto-increment)
	       (login      (char 16) not-null)
	       (name       (varchar 75) not-null)
	       (passwd     (char 16) not-null)
	       (primary-key adminid)))

(create-table admin_host
	      ((adminid    smallint unsigned not-null)
	       (hostid     smallint unsigned not-null)
	       (primary-key adminid hostid)))

(create-table kid
	      ((id         int unsigned not-null auto-increment)
	       (kid        (enum users process processor fs memory network nfs printer))
	       (hostid     smallint unsigned not-null)
	       (ts         timestamp)
	       (primary-key id)))

(create-table users
	      ((id         int unsigned not-null)
	       (user       (char 16) not-null)
	       (tty        (char 10) not-null)
	       (remote     (char 20) not-null)
	       (process    (char 128) not-null)
	       (sessions   tinyint unsigned not-null)
	       (login_at   (char 10))))

(create-table process
	      ((id         int unsigned not-null)
	       (total      smallint unsigned not-null)
	       (demons     smallint unsigned not-null)
	       (system     smallint unsigned not-null)
	       (user       smallint unsigned not-null)
	       (run        smallint unsigned not-null)
	       (sleep      smallint unsigned not-null)
	       (zombie     smallint unsigned not-null)
	       (primary-key id)))

(create-table processor
	      ((id         int unsigned not-null)
	       (load_avg   (float 3 2) not-null)
	       (user       smallint unsigned not-null)
	       (system     smallint unsigned not-null)
	       (idle       smallint unsigned not-null)
	       (primary-key id)))

(create-table fs
	      ((id         int unsigned not-null)
	       (fs         (char 64) not-null)
	       (blocks     mediumint unsigned not-null)
	       (used       mediumint unsigned not-null)
	       (available  mediumint unsigned not-null)
	       (percent    tinyint unsigned not-null)
	       (mountat    (char 128) not-null)
	       (primary-key id fs)))

(create-table memory
	      ((id         int unsigned not-null)
	       (total      int unsigned not-null)
	       (used       int unsigned not-null)
	       (free       int unsigned not-null)
	       (shared     int unsigned not-null)
	       (cached     int unsigned not-null)
	       (swap       int unsigned not-null)
	       (s_used     int unsigned not-null)
	       (s_free     int unsigned not-null)
	       (primary-key id)))

(create-table network
	      ((id         int unsigned not-null)
	       (interface  (char 10) not-null)
	       (bytes_r    int unsigned not-null)
	       (packets_r  int unsigned not-null)
	       (errors_r   int unsigned not-null)
	       (drops_r    int unsigned not-null)
	       (overs_r    int unsigned not-null)
	       (bytes_t    int unsigned not-null)
	       (packets_t  int unsigned not-null)
	       (errors_t   int unsigned not-null)
	       (drops_t    int unsigned not-null)
	       (overs_t    int unsigned not-null)
	       (colls      int unsigned not-null)
	       (primary-key id interface)))

(create-table nfs
	      ((id         int unsigned not-null)
	       (imported   tinyint unsigned not-null)
	       (exported   tinyint unsigned not-null)
	       (mounted    tinyint unsigned not-null)
	       (primary-key id)))

(create-table printer
	      ((id         int unsigned not-null)
	       (printer    (char 10) not-null)
	       (queueing   tinyint unsigned not-null)
	       (printing   tinyint unsigned not-null)
	       (entries    tinyint unsigned not-null)
	       (primary-key id printer)))
