;;;
;;; <sismo.ss> ---- CGI principal del SisMo
;;;
;;; Copyright (C) 2001 by Karla Ramrez. 
;;;
;;; This file is part of SisMo.

;;; SisMo is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public
;;; License as published by the Free Software Foundation; either
;;; version 2.1 of the License, or (at your option) any later version.

;;; SisMo is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.

;;; You should have received a copy of the GNU Lesser General Public
;;; License along with SisMo; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;;; Author: Karla Ramrez <karla@wish.com.mx>
;;
;;
;; Commentary:

(unit/sig
 ()
 (import cgi^)

 ;; En este archivo estn detalles de configuracin del SisMo:
 (include "../../config.ss")
 (include "util.ss")
 (include "sismo-admin.ss")
   
 (let ((action (extract-binding 'action bindings))
       (menu (read-menu "error" "Opciones"))
       (real-body (list `(p (strong "Error: Liga incorrecta.") " por favor vuelva a intentarlo, gracias.")))
       )

   (when action
	 (cond ((string=? action "login")
		(let-values
		 ([(ok? data) (sismo-login bindings)])
		 (cond (ok? ;; Login y password concuerdan!
			(sismo-main-page data)
			(set! real-body `((p (strong "Gracias, hasta pronto!"))))
			)
		       (else
			(set! real-body
			      `((h1 "Error")
				(p "Lo siento mucho, pero los datos proporcionados son incorrectos.  Por favor regresa y revisa tu login y password, gracias.")))))))
	       ((string=? action "help")
		(set! real-body (read-page "help")))))

   `(html
     (head
      (meta ((name "author") (content "Karla Ramrez (SisMo, powered by PLT Scheme)")))
      (meta ((name "keywords") (content "SisMo, sistema de monitoreo")))
      (link ((href "/style.css") (type "text/css") (rel "stylesheet")))
      (title "SisMo: Sistema de Monitoreo para Linux"))
     (body ((bgcolor "#ffffff"))
	   ;; Encabezado
	   ,@title
	   ;; Cuerpo
	   (table ((width "100%") (border "0") (cellpadding "5"))
		  (tbody ()
			 (tr ()
			     (td ((valign "top") (width "110"))
				 ,@menu)
			     (td ((valign "top") (width "100%"))
				 ,@real-body))
			 ,@footer))))))

;;; sismo.ss ends here